From 2d7f1174944fade92075e0402d3924371d24a0b5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 00:58:31 +0000
Subject: [PATCH 1121/2232] Make Str, Slice trivially copy assignable


---

diff --git a/include/cxx.h b/include/cxx.h
index 04a63d6..3499fec 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -66,7 +66,7 @@ public:
   Str(const char *, size_t);
   Str(std::string &&) = delete;
 
-  Str &operator=(Str) noexcept;
+  Str &operator=(const Str &) noexcept = default;
 
   explicit operator std::string() const;
 
@@ -94,7 +94,7 @@ public:
   Slice() noexcept;
   Slice(const T *, size_t count) noexcept;
 
-  Slice &operator=(Slice<T>) noexcept;
+  Slice &operator=(const Slice<T> &) noexcept = default;
 
   const T *data() const noexcept;
   size_t size() const noexcept;
@@ -329,12 +329,6 @@ template <typename T>
 Slice<T>::Slice(const T *s, size_t count) noexcept : repr(Repr{s, count}) {}
 
 template <typename T>
-Slice<T> &Slice<T>::operator=(Slice<T> other) noexcept {
-  this->repr = other.repr;
-  return *this;
-}
-
-template <typename T>
 const T *Slice<T>::data() const noexcept {
   return this->repr.ptr;
 }
diff --git a/src/cxx.cc b/src/cxx.cc
index 7e9f57e..d423ab7 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -139,12 +139,6 @@ Str::Str(const char *s, size_t len)
   initStr(this->ptr, this->len);
 }
 
-Str &Str::operator=(Str other) noexcept {
-  this->ptr = other.ptr;
-  this->len = other.len;
-  return *this;
-}
-
 Str::operator std::string() const {
   return std::string(this->data(), this->size());
 }

